export interface IContextMenuUIItem {
  text: string;
  key: string;
  tips?: React.ReactNode;
  shortcutKeyDesc?: React.ReactNode;
  disable?: boolean;
  hide?: boolean;
  /**
   * 菜单层级顺序，按照数字大小排序，数字越小越靠前，0在最前面
   */
  index?: number;
  icon?: React.ReactNode;
  // 用户用来透传自定义数据的属性
  customData?: any;
  children?: IContextMenuUIItem[];
  onTrigger?: (menu: IContextMenuItem) => void;
}

export interface IContextMenuItem {
  key: string;
  text: string | ((ctx: ITriggerContext) => string) | ((ctx: ITriggerContext) => Promise<boolean>);
  disable?: boolean | ((ctx: ITriggerContext) => boolean) | ((ctx: ITriggerContext) => Promise<boolean>);
  hide?: boolean | ((ctx: ITriggerContext) => boolean)| ((ctx: ITriggerContext) => Promise<boolean>);
  tips?: React.ReactNode | ((ctx: ITriggerContext) => React.ReactNode);
  icon?: React.ReactNode | ((ctx: ITriggerContext) => React.ReactNode);
  /**
   * 菜单层级顺序，按照数字大小排序，数字越小越靠前，0在最前面
   */
  index?: number;
  shortcutKeyDesc?: React.ReactNode;
  customData?: any;
  children?:
    | IContextMenuItem[]
    | ((ctx: ITriggerContext) => IContextMenuItem[]);
  onTrigger?: (menu: IContextMenuItem) => void;
}

export interface Point {
  x: number;
  y: number;
}

export type ITriggerContext = Record<string, any>;
